Arch Site

From FreeCAD Documentation
Revision as of 16:18, 28 August 2021 by Heda (talk | contribs)

Arch Site

Меню прокату
Arch → Site
Верстаки
Arch
Ярлик за умовчанням
S I
Введено у версії
-
Дивись також
Arch Floor, Arch Building

Description

The Arch Site is a special object that combines properties of a standard FreeCAD group object and Arch objects. It is particularly suited for representing a whole project site, or terrain. In IFC-based architectural work, it is mostly used to organize your model, by containing building objects. The site is also used to manage and display a physical terrain, and can computes volumes of earth to be added or removed.

Usage

  1. Optionally, select one or more objects to be included in your new site.
  2. Press the Arch Site button, or press the S then I keys.

Options

  • After creating a site, you can add more objects to it by drag and dropping them in the Tree View or by using the Arch Add tool. This only determines which object is part of the given site, and has no effect on the terrain itself.
  • You can remove objects from a site by drag and dropping them out of it the Tree View or by using the Arch Remove tool
  • You can add a terrain object by editing the Site's ДаніTerrain property. The terrain must be an open shell or surface.
  • You can add volumes to be added or subtracted from the base terrain, by double-clicking the Site, and adding objects to its Subtractions or Additions groups. The objects must be solids.
  • The ДаніExtrusion Vector property can be used to solve some problems that can appear when working with subtractions and additions. In order to perform those additions/subtractions, the terrain surface is extruded into a solid, which is then appropriately unioned/subtracted. Depending on the terrain topology, this extrusion might fail with the default extrusion vector. You might therefore be able to remedy the problem by changing this to a different value.

Properties

Data

  • ДаніTerrain: The base terrain of this site
  • ДаніAddress: The street and housenumber of this site
  • ДаніPostal Code: The postal or zip code of this site
  • ДаніCity: The city of this site
  • ДаніCountry: The country of this site
  • ДаніLatitude: The latitude of this site
  • ДаніLongitude: The longitude of this site
  • ДаніUrl: An url that shows this site in a mapping website
  • ДаніProjected Area: The area of the projection of this object onto the XY plane
  • ДаніPerimeter: The perimeter length of this terrain
  • ДаніAddition Volume: The volume of earth to be added to this terrain
  • ДаніSubtraction Volume: The volume of earth to be removed from this terrain
  • ДаніExtrusion Vector: An extrusion vector to use when performing boolean operations
  • ДаніRemove Splitter: Remove splitters from the resulting shape
  • ДаніDeclination: The angle between the true North and the North direction in this document, that is, the Y axis. introduced in version 0.18 This means that by default North points to the Y axis, and East to the X axis; the angle increments counterclockwise. This property was previously known as ДаніNorth Deviation.
  • ДаніEPW File: Allow to attach an EPW file from the Ladybug EPW data website to this site. This is needed to display wind rose diagrams introduced in version 0.19

View

  • ВиглядSolar Diagram: Shows or hides the solar diagram
  • ВиглядSolar Diagram Color: The color of the solar diagram
  • ВиглядSolar Diagram Position: The position of the solar diagram
  • ВиглядSolar Diagram Scale: The scale of the solar diagram
  • ВиглядWind Rose: Shows or hides the wind rose diagram (requires the EPW File data property filled, and the Ladybug Python module installed (see below)

Typical workflow

Start by creating an object that represents your terrain. It must be an open surface, not a solid. For example, it is easy to import mesh data, that can be turned into a Part Shape from menu Part → Create Shape from Mesh. Then, create a Site object, and set its ДаніTerrain property to the Part we just created:

Create some volumes (they must be solids) that represent the areas that you wish to be excavated or filled. Double-click the Site object in the Tree View, and add these volumes to the Additions or Subtractions groups. Click OK.

The site geometry will be recomputed and the areas, perimeter, and volumes properties recalculated.

Solar and wind diagrams

If Ladybug is installed on your system, Arch Sites can display a solar diagram and/or a wind rose. For this, ДаніLongitude, ДаніLatitude and ДаніDeclination (previously ДаніNorth Deviation) must be correctly set, and ВиглядSolar Diagram or ВиглядWind Rose set to true. Respectively introduced in version 0.17 and introduced in version 0.19


Note: If you don't have Ladybug, pysolar is still supported to generate solar diagrams, but not wind roses. Pysolar 0.7 or above is required; this version only works with Python 3. If you require this feature with Python 2, you should have Pysolar 0.6 as this is the last version that works with Python 2. However, Ladybug is a much more powerful tool that will probably be used more in the future, so we recommend using it instead of pysolar. Ladybug can be installed simply via pip.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Site tool can be used in macros and from the Python console by using the following function:

Site = makeSite(objectslist=None, baseobj=None, name="Site")
  • Creates a Site object from objectslist, which is a list of objects, or baseobj, which is a Shape or Terrain.

Example:

import FreeCAD, Draft, Arch

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
baseline = Draft.makeLine(p1, p2)
Wall = Arch.makeWall(baseline, length=None, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

Building = Arch.makeBuilding([Wall])
Site = Arch.makeSite([Building])

FreeCAD.ActiveDocument.recompute()
FreeCAD.Gui.ActiveDocument.ActiveView.viewIsometric()

Solar diagram

As long as the pysolar module is present, a solar diagram can be added to the site. Set the longitude, latitude and declination angles as appropriate, as well as an adequate scale for the size of your model.

Please note that Pysolar 0.7 or above is required, and this version only works with Python 3.

Site.Longitude = -46.38
Site.Latitude = -23.33
Site.Declination = 30
#Site.Compass = True

Site.ViewObject.SolarDiagram = True
Site.ViewObject.SolarDiagramScale = 10000
FreeCAD.ActiveDocument.recompute()

Solar diagram independent of Site

A solar diagram can be created with the following function, independently of any site.

Node = makeSolarDiagram(longitude, latitude, scale=1, complete=False)
  • Creates a solar diagram as a Pivy node, using longitude and latitude, with an optional scale.
  • If complete is True, the 12 months are drawn, which shows the full solar analemma.
import FreeCADGui, Arch

Node = Arch.makeSolarDiagram(-46.38, -23.33, scale=10000, complete=True)
FreeCAD.Gui.ActiveDocument.ActiveView.getSceneGraph().addChild(Node)